from abc import ABC

from .mongo import Model


class User(Model):

    def to_dict(self):
        res = {}
        if self.__id is not None:
            res["_id"] = self.__id
        if self.__first_name is not None:
            res["first_name"] = self.__first_name
        if self.__last_name is not None:
            res["last_name"] = self.__last_name

    def __init__(self, first_name, last_name, email, hashed_password):
        self.__id = ""
        self.__first_name = first_name
        self.__last_name = last_name
        self.__email = email
        self.__hashed_password = hashed_password

    def get_collection(self):
        return self.get_db()["users"]

    def get_id(self):
        return self.__id

    def store(self):
        add_document = self.get_collection().insert_one({
            "first_name": self.__first_name,
            "last_name": self.__last_name,
            "email": self.__email,
            "hashed_password": self.__hashed_password,
        })
        self.__id = str(add_document.inserted_id)

    @staticmethod
    def find_by_username(self, email):
        return self.get_collection().find_one({"email": email})
